#include <iostream>
#include <netstream/netstream.h>

using namespace std;

const int port = 1234;

void main(void)
{
	netserver server;
	netstream remote;

#ifdef _WIN32
	WinsockStartup();
#endif

	// Place the server in listening state
	if(server.listen(port) == false)
	{
		cout << "Unable to start server" << endl;
		return;
	}

	cout << "Waiting for new connection" << endl;

	// Wait until someone connects. Check every second.
	while(server.canaccept() == false) Sleep(1000);

	// Accept the new connection and attach it to remote
	if(server.accept(remote) == false)
	{
		cout << "Unable to accept new connection" << endl;
		return;
	}

	// Close the server.
	// Note that this only closes the server socket so new connections
	// cannot be established. It does not close any connection already established.
	server.close();

	// Send a message to our new user, telling him/her we have a connection.
	remote << "Connection established" << "\n\r";
	cout   << "Connection accpeted" << endl;

	while(true)
	{
		byte c;

		if(remote.canrecv() != 0)
		{
			// Receive a byte from the stream
			remote >> c;

			// If it was a lower case 'q', exit the server loop
			if(c == 'q') break;

			// Print the character and send if back
			cout << c;
			remote << c;
		}

		// If the connection is suddenly no longer open, canrecv probably noticed
		// that we lost connection to the host and closed it.
		if(remote.isopen() == false)
		{
			cout << "Lost connection to remote host" << endl;
			return;
		}

		Sleep(10);
	}

	// Stream a string to the remote computer and close the conneciton.
	remote << "Closing connection" << "\n\r";
	remote.close();

#ifdef _WIN32
	WinsockCleanup();
#endif
}